#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivitySailingZhaocaiPigCFG.h"
std::auto_ptr<M_ActivitySailingZhaocaiPigCFG> M_ActivitySailingZhaocaiPigCFG::msSingleton(nullptr);

int M_ActivitySailingZhaocaiPigCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySailingZhaocaiPigCFGData* M_ActivitySailingZhaocaiPigCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivitySailingZhaocaiPigCFGData>& M_ActivitySailingZhaocaiPigCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySailingZhaocaiPigCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivitySailingZhaocaiPigCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySailingZhaocaiPigCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mVipLevel = element->IntAttribute("VipLevel");
		data.mDesc1 = element->Attribute("Desc1");
		data.mDesc2 = element->Attribute("Desc2");
		data.mFishGold = element->IntAttribute("FishGold");
		data.mOnlineGold = element->IntAttribute("OnlineGold");
		data.mMaxFishGold = element->IntAttribute("MaxFishGold");
		data.mMaxOnlineGold = element->IntAttribute("MaxOnlineGold");
		data.mPigName = element->Attribute("PigName");
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivitySailingZhaocaiPigCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySailingZhaocaiPigCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivitySailingZhaocaiPigCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivitySailingZhaocaiPigCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivitySailingZhaocaiPigCFGData data;
		LuaCfgHelper::readInt(L, "Id", data.mId);
		LuaCfgHelper::readInt(L, "VipLevel", data.mVipLevel);
		LuaCfgHelper::readString(L, "Desc1", data.mDesc1);
		LuaCfgHelper::readString(L, "Desc2", data.mDesc2);
		LuaCfgHelper::readInt(L, "FishGold", data.mFishGold);
		LuaCfgHelper::readInt(L, "OnlineGold", data.mOnlineGold);
		LuaCfgHelper::readInt(L, "MaxFishGold", data.mMaxFishGold);
		LuaCfgHelper::readInt(L, "MaxOnlineGold", data.mMaxOnlineGold);
		LuaCfgHelper::readString(L, "PigName", data.mPigName);
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivitySailingZhaocaiPigCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySailingZhaocaiPigCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivitySailingZhaocaiPigCFG* M_ActivitySailingZhaocaiPigCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySailingZhaocaiPigCFG());
	}
	return msSingleton.get();
}

void M_ActivitySailingZhaocaiPigCFG::Release()
{
	msSingleton.reset(nullptr);
}
